diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/motion_comp_mmx.c
--- a/src/libmpeg2/motion_comp_mmx.c	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/motion_comp_mmx.c	Wed Jul 04 03:09:58 2007 +0300
@@ -910,97 +903,97 @@ MPEG2_MC_EXTERN (mmxext)
 
 
 
-static void MC_avg_o_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_o_16_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg1_16 (height, dest, ref, stride, CPU_3DNOW);
 }
 
-static void MC_avg_o_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_o_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_avg1_8 (height, dest, ref, stride, CPU_3DNOW);
 }
 
-static void MC_put_o_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_o_16_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put1_16 (height, dest, ref, stride);
 }
 
-static void MC_put_o_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_o_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_put1_8 (height, dest, ref, stride);
 }
 
-static void MC_avg_x_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_x_16_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg2_16 (height, dest, ref, stride, 1, CPU_3DNOW);
 }
 
-static void MC_avg_x_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_x_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_avg2_8 (height, dest, ref, stride, 1, CPU_3DNOW);
 }
 
-static void MC_put_x_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_x_16_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put2_16 (height, dest, ref, stride, 1, CPU_3DNOW);
 }
 
-static void MC_put_x_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_x_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_put2_8 (height, dest, ref, stride, 1, CPU_3DNOW);
 }
 
-static void MC_avg_y_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_y_16_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg2_16 (height, dest, ref, stride, stride, CPU_3DNOW);
 }
 
-static void MC_avg_y_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_y_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_avg2_8 (height, dest, ref, stride, stride, CPU_3DNOW);
 }
 
-static void MC_put_y_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_y_16_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put2_16 (height, dest, ref, stride, stride, CPU_3DNOW);
 }
 
-static void MC_put_y_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_y_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_put2_8 (height, dest, ref, stride, stride, CPU_3DNOW);
 }
 
-static void MC_avg_xy_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_xy_16_3dnow (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_avg4_16 (height, dest, ref, stride, CPU_3DNOW);
 }
 
-static void MC_avg_xy_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_avg_xy_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg4_8 (height, dest, ref, stride, CPU_3DNOW);
 }
 
-static void MC_put_xy_16_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_xy_16_3dnow (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_put4_16 (height, dest, ref, stride, CPU_3DNOW);
 }
 
-static void MC_put_xy_8_3dnow (uint8_t * dest, uint8_t * ref,
+static void MC_put_xy_8_3dnow (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put4_8 (height, dest, ref, stride, CPU_3DNOW);
diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/motion_comp_vis.c
--- a/src/libmpeg2/motion_comp_vis.c	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/motion_comp_vis.c	Wed Jul 04 03:09:58 2007 +0300
@@ -26,6 +26,8 @@
 
 #include <inttypes.h>
 
+#include "mpeg2.h"
+#include "attributes.h"
 #include "mpeg2_internal.h"
 #include "vis.h"
 
@@ -116,8 +118,8 @@ static const int16_t constants256_1024[]
 #define TMP30		56
 #define TMP32		58
 
-static void MC_put_o_16_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_put_o_16_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int offset;
@@ -141,8 +143,8 @@ static void MC_put_o_16_vis (uint8_t * d
 	} while (--height);
 }
 
-static void MC_put_o_8_vis (uint8_t * dest, uint8_t * _ref,
-			    int stride, int height)
+static void MC_put_o_8_vis (uint8_t * dest, const uint8_t * _ref,
+			    const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int offset;
@@ -164,8 +166,8 @@ static void MC_put_o_8_vis (uint8_t * de
 }
 
 
-static void MC_avg_o_16_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_avg_o_16_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int stride_8 = stride + 8;
@@ -327,8 +329,8 @@ static void MC_avg_o_16_vis (uint8_t * d
 	vis_st64_2(TMP22, dest, 8);
 }
 
-static void MC_avg_o_8_vis (uint8_t * dest, uint8_t * _ref,
-			    int stride, int height)
+static void MC_avg_o_8_vis (uint8_t * dest, const uint8_t * _ref,
+			    const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int offset;
@@ -423,8 +425,8 @@ static void MC_avg_o_8_vis (uint8_t * de
 	vis_st64(TMP4, dest[0]);
 }
 
-static void MC_put_x_16_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_put_x_16_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -616,8 +618,8 @@ static void MC_put_x_16_vis (uint8_t * d
 	vis_st64_2(TMP8, dest, 8);
 }
 
-static void MC_put_x_8_vis (uint8_t * dest, uint8_t * _ref,
-			    int stride, int height)
+static void MC_put_x_8_vis (uint8_t * dest, const uint8_t * _ref,
+			    const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -740,8 +742,8 @@ static void MC_put_x_8_vis (uint8_t * de
 	dest += stride;
 }
 
-static void MC_avg_x_16_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_avg_x_16_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -831,8 +833,8 @@ static void MC_avg_x_16_vis (uint8_t * d
 	} while (--height);
 }
 
-static void MC_avg_x_8_vis (uint8_t * dest, uint8_t * _ref,
-			    int stride, int height)
+static void MC_avg_x_8_vis (uint8_t * dest, const uint8_t * _ref,
+			    const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -997,8 +999,8 @@ static void MC_avg_x_8_vis (uint8_t * de
 	} while (--height);
 }
 
-static void MC_put_y_16_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_put_y_16_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int offset;
@@ -1156,8 +1158,8 @@ static void MC_put_y_16_vis (uint8_t * d
 	vis_st64_2(TMP2, dest, 8);
 }
 
-static void MC_put_y_8_vis (uint8_t * dest, uint8_t * _ref,
-			    int stride, int height)
+static void MC_put_y_8_vis (uint8_t * dest, const uint8_t * _ref,
+			    const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int offset;
@@ -1251,8 +1253,8 @@ static void MC_put_y_8_vis (uint8_t * de
 	vis_st64(DST_0, dest[0]);
 }
 
-static void MC_avg_y_16_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_avg_y_16_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int stride_8 = stride + 8;
@@ -1383,8 +1385,8 @@ static void MC_avg_y_16_vis (uint8_t * d
 	} while (--height);
 }
 
-static void MC_avg_y_8_vis (uint8_t * dest, uint8_t * _ref,
-			    int stride, int height)
+static void MC_avg_y_8_vis (uint8_t * dest, const uint8_t * _ref,
+			    const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	int stride_8;
@@ -1466,8 +1468,8 @@ static void MC_avg_y_8_vis (uint8_t * de
 	} while (--height);
 }
 
-static void MC_put_xy_16_vis (uint8_t * dest, uint8_t * _ref,
-			      int stride, int height)
+static void MC_put_xy_16_vis (uint8_t * dest, const uint8_t * _ref,
+			      const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -1631,8 +1633,8 @@ static void MC_put_xy_16_vis (uint8_t * 
 	} while (--height);
 }
 
-static void MC_put_xy_8_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_put_xy_8_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -1736,8 +1738,8 @@ static void MC_put_xy_8_vis (uint8_t * d
 	} while (--height);
 }
 
-static void MC_avg_xy_16_vis (uint8_t * dest, uint8_t * _ref,
-			      int stride, int height)
+static void MC_avg_xy_16_vis (uint8_t * dest, const uint8_t * _ref,
+			      const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
@@ -1933,8 +1935,8 @@ static void MC_avg_xy_16_vis (uint8_t * 
 	} while (--height);
 }
 
-static void MC_avg_xy_8_vis (uint8_t * dest, uint8_t * _ref,
-			     int stride, int height)
+static void MC_avg_xy_8_vis (uint8_t * dest, const uint8_t * _ref,
+			     const int stride, int height)
 {
 	uint8_t *ref = (uint8_t *) _ref;
 	unsigned long off = (unsigned long) ref & 0x7;
diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/mpeg2.h
--- a/src/libmpeg2/mpeg2.h	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/mpeg2.h	Wed Jul 04 03:09:58 2007 +0300
@@ -25,6 +25,10 @@
 #define MPEG2_H
 
 #include "libmpeg2_accel.h"
+
+#ifndef HAVE_SPU_API_H
+typedef struct spu_decoder_s * spu_decoder_t;
+#endif
 
 typedef struct mpeg2dec_s {
     xine_video_port_t * output;
diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/mpeg2_internal.h
--- a/src/libmpeg2/mpeg2_internal.h	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/mpeg2_internal.h	Wed Jul 04 03:09:58 2007 +0300
@@ -1,6 +1,6 @@
 /*
  * mpeg2_internal.h
- * Copyright (C) 2000-2002 Michel Lespinasse <walken@zoy.org>
+ * Copyright (C) 2000-2003 Michel Lespinasse <walken@zoy.org>
  * Copyright (C) 1999-2000 Aaron Holtzman <aholtzma@ess.engr.uvic.ca>
  *
  * This file is part of mpeg2dec, a free MPEG-2 video stream decoder.
@@ -52,13 +52,15 @@
 #define BOTTOM_FIELD  VO_BOTTOM_FIELD
 #define FRAME_PICTURE VO_BOTH_FIELDS
 
-/* picture coding type (mpeg2 header) */
+/* picture coding type */
 #define I_TYPE 1
 #define P_TYPE 2
 #define B_TYPE 3
 #define D_TYPE 4
-               
-typedef struct motion_s {
+
+typedef void mpeg2_mc_fct (uint8_t *, const uint8_t *, int, int);
+
+typedef struct {
     uint8_t * ref[2][3];
     uint8_t ** ref2[2];
     int pmv[2][2];
@@ -70,8 +72,7 @@ typedef struct picture_s {
     /* next inside a slice, and is never used outside of mpeg2_slice() */
 
     /* DCT coefficients - should be kept aligned ! */
-    int16_t DCTblock[64];
-
+    int16_t DCTblock[64] ATTR_ALIGN(64);
     /* XvMC DCT block and macroblock data for XvMC acceleration */
     xine_macroblocks_t *mc;
     int XvMC_mb_type;
@@ -207,6 +208,9 @@ typedef struct cpu_state_s {
     int dummy;
 } cpu_state_t;
 
+/* cpu_accel.c */
+/*uint32_t mpeg2_detect_accel (void);*/
+
 /* cpu_state.c */
 extern void (* mpeg2_cpu_state_save) (cpu_state_t * state);
 extern void (* mpeg2_cpu_state_restore) (cpu_state_t * state);
@@ -223,25 +227,19 @@ int mpeg2_header_group_of_pictures (pict
 
 /* idct.c */
 extern void (* mpeg2_idct_copy) (int16_t * block, uint8_t * dest, int stride);
-extern void (* mpeg2_idct_add) (int16_t * block, uint8_t * dest, int stride);
+extern void (* mpeg2_idct_add) (const int last, int16_t * block, uint8_t * dest, int stride);
 extern void (* mpeg2_idct) (int16_t * block);
 extern void (* mpeg2_zero_block) (int16_t * block);
 void mpeg2_idct_init (uint32_t mm_accel);
 
-/* idct_mlib.c */
-void mpeg2_idct_add_mlib (int16_t * block, uint8_t * dest, int stride);
-void mpeg2_idct_copy_mlib_non_ieee (int16_t * block, uint8_t * dest,
-				    int stride);
-void mpeg2_idct_add_mlib_non_ieee (int16_t * block, uint8_t * dest,
-				   int stride);
-void mpeg2_idct_mlib (int16_t * block);
-
 /* idct_mmx.c */
 void mpeg2_idct_copy_mmxext (int16_t * block, uint8_t * dest, int stride);
-void mpeg2_idct_add_mmxext (int16_t * block, uint8_t * dest, int stride);
+void mpeg2_idct_add_mmxext (int last, int16_t * block,
+			    uint8_t * dest, int stride);
 void mpeg2_idct_mmxext (int16_t * block);
 void mpeg2_idct_copy_mmx (int16_t * block, uint8_t * dest, int stride);
-void mpeg2_idct_add_mmx (int16_t * block, uint8_t * dest, int stride);
+void mpeg2_idct_add_mmx (int last, int16_t * block,
+			 uint8_t * dest, int stride);
 void mpeg2_idct_mmx (int16_t * block);
 void mpeg2_zero_block_mmx (int16_t * block);
 void mpeg2_idct_mmx_init (void);
@@ -250,22 +248,30 @@ void mpeg2_idct_mmx_init (void);
 # ifdef ENABLE_ALTIVEC
 void mpeg2_idct_copy_altivec (vector signed short * block, unsigned char * dest,
 			      int stride);
-void mpeg2_idct_add_altivec (vector signed short * block, unsigned char * dest,
+void mpeg2_idct_add_altivec (const int last, vector signed short * block, unsigned char * dest,
 			     int stride);
 # else /* ! ENABLE_ALTIVEC */
-void mpeg2_idct_copy_altivec (signed short * block, unsigned char * dest,
-			      int stride);
-void mpeg2_idct_add_altivec (signed short * block, unsigned char * dest,
-			     int stride);
+void mpeg2_idct_copy_altivec (int16_t * block, uint8_t * dest, int stride);
+void mpeg2_idct_add_altivec (int last, int16_t * block,
+			     uint8_t * dest, int stride);
 # endif /* ENABLE_ALTIVEC */
 void mpeg2_idct_altivec_init (void);
 
+/* idct_alpha.c */
+void mpeg2_idct_copy_mvi (int16_t * block, uint8_t * dest, int stride);
+void mpeg2_idct_add_mvi (int last, int16_t * block,
+			 uint8_t * dest, int stride);
+void mpeg2_idct_copy_alpha (int16_t * block, uint8_t * dest, int stride);
+void mpeg2_idct_add_alpha (int last, int16_t * block,
+			   uint8_t * dest, int stride);
+void mpeg2_idct_alpha_init (void);
+
 /* motion_comp.c */
-void mpeg2_mc_init (uint32_t mm_accel);
-
-typedef struct mpeg2_mc_s {
-    void (* put [8]) (uint8_t * dst, uint8_t *, int32_t, int32_t);
-    void (* avg [8]) (uint8_t * dst, uint8_t *, int32_t, int32_t);
+void mpeg2_mc_init (uint32_t accel);
+
+typedef struct {
+    mpeg2_mc_fct * put [8];
+    mpeg2_mc_fct * avg [8];
 } mpeg2_mc_t;
 
 #define MPEG2_MC_EXTERN(x) mpeg2_mc_t mpeg2_mc_##x = {			  \
@@ -281,7 +287,7 @@ extern mpeg2_mc_t mpeg2_mc_mmxext;
 extern mpeg2_mc_t mpeg2_mc_mmxext;
 extern mpeg2_mc_t mpeg2_mc_3dnow;
 extern mpeg2_mc_t mpeg2_mc_altivec;
-extern mpeg2_mc_t mpeg2_mc_mlib;
+extern mpeg2_mc_t mpeg2_mc_alpha;
 extern mpeg2_mc_t mpeg2_mc_vis;
 
 /* slice.c */
diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/slice.c
--- a/src/libmpeg2/slice.c	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/slice.c	Wed Jul 04 03:09:58 2007 +0300
@@ -575,7 +575,7 @@ static void get_intra_block_B15 (picture
     picture->bitstream_ptr = bit_ptr;
 }
 
-static void get_non_intra_block (picture_t * picture)
+static int get_non_intra_block (picture_t * picture)
 {
     int i;
     int j;
@@ -696,6 +696,7 @@ static void get_non_intra_block (picture
     picture->bitstream_buf = bit_buf;
     picture->bitstream_bits = bits;
     picture->bitstream_ptr = bit_ptr;
+    return i;
 }
 
 static void get_mpeg1_intra_block (picture_t * picture)
@@ -817,7 +818,7 @@ static void get_mpeg1_intra_block (pictu
     picture->bitstream_ptr = bit_ptr;
 }
 
-static void get_mpeg1_non_intra_block (picture_t * picture)
+static int get_mpeg1_non_intra_block (picture_t * picture)
 {
     int i;
     int j;
@@ -944,6 +945,7 @@ static void get_mpeg1_non_intra_block (p
     picture->bitstream_buf = bit_buf;
     picture->bitstream_bits = bits;
     picture->bitstream_ptr = bit_ptr;
+    return i;
 }
 
 static inline void slice_intra_DCT (picture_t * picture, int cc,
@@ -977,11 +979,12 @@ static inline void slice_non_intra_DCT (
 static inline void slice_non_intra_DCT (picture_t * picture, uint8_t * dest,
 					int stride)
 {
+    int last;
     if (picture->mpeg1)
-	get_mpeg1_non_intra_block (picture);
+	last = get_mpeg1_non_intra_block (picture);
     else
-	get_non_intra_block (picture);
-    mpeg2_idct_add (picture->DCTblock, dest, stride);
+	last = get_non_intra_block (picture);
+    mpeg2_idct_add (last, picture->DCTblock, dest, stride);
 }
 
 #define MOTION(table,ref,motion_x,motion_y,size,y)			      \
@@ -1045,8 +1048,9 @@ static inline void slice_non_intra_DCT (
 		         (motion_y op) + src_field) * picture->pitches[2])),  \
 		      2 * picture->pitches[2], 4)
 
-static void motion_mp1 (picture_t * picture, motion_t * motion,
-			void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_mp1 (picture_t * picture, 
+			motion_t * const motion,
+			mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1076,8 +1080,9 @@ static void motion_mp1 (picture_t * pict
 #undef bit_ptr
 }
 
-static void motion_fr_frame (picture_t * picture, motion_t * motion,
-			     void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fr_frame (picture_t * picture, 
+			     motion_t * const motion,
+			     mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1103,8 +1108,9 @@ static void motion_fr_frame (picture_t *
 #undef bit_ptr
 }
 
-static void motion_fr_field (picture_t * picture, motion_t * motion,
-			     void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fr_field (picture_t * picture, 
+			     motion_t * const motion,
+			     mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1150,8 +1156,9 @@ static void motion_fr_field (picture_t *
 #undef bit_ptr
 }
 
-static void motion_fr_dmv (picture_t * picture, motion_t * motion,
-			   void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fr_dmv (picture_t * picture, 
+			   motion_t * const motion,
+			   mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1229,8 +1236,9 @@ static void motion_fr_dmv (picture_t * p
 #undef bit_ptr
 }
 
-static void motion_reuse (picture_t * picture, motion_t * motion,
-			  void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_reuse (picture_t * picture, 
+			  motion_t * const motion,
+			  mpeg2_mc_fct * const * const table)
 {
     int motion_x, motion_y;
     unsigned int pos_x, pos_y, xy_half;
@@ -1241,8 +1249,9 @@ static void motion_reuse (picture_t * pi
     MOTION (table, motion->ref[0], motion_x, motion_y, 16, 0);
 }
 
-static void motion_zero (picture_t * picture, motion_t * motion,
-			 void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_zero (picture_t * picture, 
+			 motion_t * const motion,
+			 mpeg2_mc_fct * const * const table)
 {
     table[0] (picture->dest[0] + picture->offset,
 	      (motion->ref[0][0] + picture->offset +
@@ -1285,8 +1294,9 @@ static void motion_fr_conceal (picture_t
 #undef bit_ptr
 }
 
-static void motion_fi_field (picture_t * picture, motion_t * motion,
-			     void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fi_field (picture_t * picture, 
+			     motion_t * const motion,
+			     mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1316,8 +1326,9 @@ static void motion_fi_field (picture_t *
 #undef bit_ptr
 }
 
-static void motion_fi_16x8 (picture_t * picture, motion_t * motion,
-			    void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fi_16x8 (picture_t * picture, 
+			    motion_t * const motion,
+			    mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1364,8 +1375,9 @@ static void motion_fi_16x8 (picture_t * 
 #undef bit_ptr
 }
 
-static void motion_fi_dmv (picture_t * picture, motion_t * motion,
-			   void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fi_dmv (picture_t * picture, 
+			   motion_t * const motion,
+			   mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/slice_xvmc.c
--- a/src/libmpeg2/slice_xvmc.c	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/slice_xvmc.c	Wed Jul 04 03:09:58 2007 +0300
@@ -1122,8 +1122,9 @@ static inline void slice_xvmc_non_intra_
     picture->mc->blockptr += 64;
 }
 
-static void motion_mp1 (picture_t * picture, motion_t * motion,
-			void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_mp1 (picture_t * picture, 
+			motion_t * const motion,
+			mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1151,8 +1152,9 @@ static void motion_mp1 (picture_t * pict
 #undef bit_ptr
 }
 
-static void motion_fr_frame (picture_t * picture, motion_t * motion,
-			     void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fr_frame (picture_t * picture, 
+			     motion_t * const motion,
+			     mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1176,8 +1178,9 @@ static void motion_fr_frame (picture_t *
 #undef bit_ptr
 }
 
-static void motion_fr_field (picture_t * picture, motion_t * motion,
-			     void (** table) (uint8_t *, uint8_t *, int, int),
+static void motion_fr_field (picture_t * picture, 
+			     motion_t * const motion,
+			     mpeg2_mc_fct * const * const table,
 			     int dir)
 {
 #define bit_buf (picture->bitstream_buf)
@@ -1224,8 +1227,9 @@ static void motion_fr_field (picture_t *
 #undef bit_ptr
 }
 
-static void motion_fr_dmv (picture_t * picture, motion_t * motion,
-			   void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fr_dmv (picture_t * picture, 
+			   motion_t * const motion,
+			   mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1252,8 +1256,9 @@ static void motion_fr_dmv (picture_t * p
 #undef bit_ptr
 }
 
-static void motion_reuse (picture_t * picture, motion_t * motion,
-			  void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_reuse (picture_t * picture, 
+			  motion_t * const motion,
+			  mpeg2_mc_fct * const * const table)
 {
     int motion_x, motion_y;
 
@@ -1288,8 +1293,9 @@ static void motion_fr_conceal (picture_t
 #undef bit_ptr
 }
 
-static void motion_fi_field (picture_t * picture, motion_t * motion,
-			     void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fi_field (picture_t * picture, 
+			     motion_t * const motion,
+			     mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1321,8 +1327,9 @@ static void motion_fi_field (picture_t *
 #undef bit_ptr
 }
 
-static void motion_fi_16x8 (picture_t * picture, motion_t * motion,
-			    void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fi_16x8 (picture_t * picture, 
+			    motion_t * const motion,
+			    mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
@@ -1374,8 +1381,9 @@ static void motion_fi_16x8 (picture_t * 
 #undef bit_ptr
 }
 
-static void motion_fi_dmv (picture_t * picture, motion_t * motion,
-			   void (** table) (uint8_t *, uint8_t *, int, int))
+static void motion_fi_dmv (picture_t * picture, 
+			   motion_t * const motion,
+			   mpeg2_mc_fct * const * const table)
 {
 #define bit_buf (picture->bitstream_buf)
 #define bits (picture->bitstream_bits)
